unit RepoRTFO;

interface
uses SysUtils, Windows;
//  
function rtf_Open(fname:string):boolean;
//  
function rtf_Close : boolean;
//  .   
function rtf_LineFeed : boolean;
//    
function rtf_Out (nam, val:String; nlev:Integer) : boolean;
//    .
function rtf_OutR (nam:String; val:real; zn1,zn2,nlev:Integer):boolean;
//     
function rtf_OutI (nam:String; val,nlev:Integer):boolean;
//     (form="dd.mm.yyyy")   (form="hh:mm")
function rtf_OutDT (nam, form:String; val:TDateTime; nlev:Integer):boolean;

var
rtf_outtext : text;

implementation

function rtf_Open(fname:string):boolean;
var rv:boolean;
begin
  rv:=true;
  AssignFile(rtf_outtext,fname);
  try
    Rewrite(rtf_outtext);
  except
    on E: Exception do rv:=false;
    end;
 rtf_Open := rv;
end;

function rtf_Close : boolean;
var rv:boolean;
begin
  rv:=true;
  try
    CloseFile(rtf_outtext);
  except
    on E: Exception do rv:=false;
    end;
  rtf_Close := rv;
end;

function rtf_LineFeed : boolean;
var rv:boolean;
begin
  rv:=true;
  try
    Writeln(rtf_outtext);
  except
    on E: Exception do rv:=false;
    end;
  rtf_LineFeed := rv;
end;

function rtf_Out (nam, val:String; nlev:Integer) : boolean;
var rv:boolean; st:string;
begin
  rv:=true;
  Str(nlev,st);
  try
    begin
    Write(rtf_outtext,'|'+st+':'+nam+':'+val);
    if (nlev=0) then rv:=rtf_LineFeed;
    end
  except
    on E: Exception do rv:=false;
    end;
  rtf_Out := rv;
end;

function rtf_OutR (nam:String; val:real; zn1,zn2,nlev:Integer):boolean;
var st:string;
begin
  Str(val:zn1:zn2,st);
  rtf_OutR := rtf_Out(nam,Trim(st),nlev);
end;

function rtf_OutI (nam:String; val,nlev:Integer):boolean;
var st:string;
begin
  Str(val,st);
  rtf_OutI := rtf_Out(nam,Trim(st),nlev);
end;

function rtf_OutDT (nam, form:String; val:TDateTime; nlev:Integer):boolean;
begin
  rtf_OutDT := rtf_Out(nam,FormatDateTime(form,val),nlev);
end;


end.
