{*****************************************************************
     RTF.

   RepoRTFM.cpp   , " ",
      goto.

c .  RepoRTFM.cpp  doc
*****************************************************************}

{$H+,I+}
unit RepoRTFM;
interface
uses SysUtils, Windows;

type
 callingProc=function(istrd:integer):integer;

function rtf_CreateReport
(asDatFileName,        //  
 asPicFileName,        //  
 asRepFileName:string; //  
 cProc:callingProc;    //  
 var istrd:integer     //     
):integer;             // 

implementation

const
 rtf_iSSize=4096;
 rtf_ParMarker=11;

var
rtf_asParMarker:string;
rtf_Instream, rtf_Outstream : file;
rtf_asSpec :string;
rtf_maxLev :INTEGER;
rtf_RTFpic :boolean;

function atoi (S:string):integer;
var V,Code: Integer;
begin
  Val(S,V,Code);
  if Code=0 then atoi:=V else atoi:=0
end;

procedure rtf_SpecSymbols( acSpec,
 asRepl:string; var asParvalue:string);
var ib,il,ir:integer;
begin
{  for ib:=1 to Length(asParvalue) do
    if (asParvalue[ib]=acSpec) then
      asParvalue := Copy(asParvalue,1,ib-1)+asRepl+
        Copy(asParvalue,ib+1,Length(asParvalue));}
  ib:=1;
  ir:=Length(asRepl);
  il:=Length(asParvalue);
  while ib<=il do
    if (asParvalue[ib]=acSpec) then
      begin
      asParvalue := Copy(asParvalue,1,ib-1)+asRepl+
        Copy(asParvalue,ib+1,il);
      ib := ib+ir;
      il := il+ir-1;
      end
    else
      inc(ib)
end;

procedure rtf_GetParameter(
  var asDat,asParname,asParvalue:string; var curlev:integer);
var
ib :integer;
ilen :integer;
asTmp:string;
begin
 ilen :=Length(asDat);
 asTmp:=Copy(asDat,1,3);
 curlev := atoi(Copy(asTmp,2,1));
 if ((asTmp<'|0:') or (asTmp>'|9:')) then
    begin
    asParname := '';
    exit
    end;
 asDat := Copy(asDat,4,ilen);
 ib := AnsiPos(':',asDat);
 if (ib>1) then
   begin
   asParname := rtf_asParMarker+
     Copy(asDat,1,ib-1)+rtf_asParMarker;
   asDat := Copy(asDat,ib+1,ilen);
   ib := AnsiPos(asTmp,asDat);
   if (ib>0) then
     begin
     asParvalue := Copy(asDat,1,ib-1);
     asDat := Copy(asDat,ib,ilen);
     end
   else
     asParvalue := asDat;
   if rtf_RTFpic then
     begin
     rtf_SpecSymbols('\','\''5C',asParvalue);
     rtf_SpecSymbols('{','\''7B',asParvalue);
     rtf_SpecSymbols('}','\''7D',asParvalue);
     end;
   ib:=1;
   while ib>0 do
     begin
     ib := AnsiPos('|EOL:',asParvalue);
     if (ib=0) then
      begin
      ib := AnsiPos('|EOP:',asParvalue);
      if (ib>0) then
        if rtf_RTFpic then
          asParvalue := Copy(asParvalue,1,ib-1)+
            '{\page}'+Copy(asParvalue,ib+5,ilen)
        else
          asParvalue := Copy(asParvalue,1,ib-1)+
            '{\014}'+Copy(asParvalue,ib+5,ilen);
      end
     else
       if rtf_RTFpic then
         asParvalue := Copy(asParvalue,1,ib-1)+
           '{\par}'+Copy(asParvalue,ib+5,ilen)
       else
         asParvalue := Copy(asParvalue,1,ib-1)+
           #13#10+Copy(asParvalue,ib+5,ilen)
     end
   end
 else
   asParname := '';
end;

procedure rtf_StrIntoReport(
  var asStr:string; var kz:integer);
var
 i,ib,ib1,ib2:integer;
 ch:char;
 st:string;
 szIO : array[1..rtf_iSSize] of char;
begin
  st:=' ';
  ib:=1;
  ib1:=Length(asStr);
  while ib<=ib1 do
    begin
    ch := asStr[ib];
    i := ord(ch);
    if (((i>0) and (i<rtf_maxLev))
    or (i=rtf_ParMarker)) then
      begin
      st[1] := ch;
      ib2 := AnsiPos(st,Copy(asStr,ib+1,ib1));
      asStr := Copy(asStr,1,ib-1)+
        Copy(asStr,ib+ib2+1,ib1);
      end
    else
      inc(ib);
    ib1:=Length(asStr);
    end;
 ib :=1;
 while (kz=0) and (ib>0) do
   begin
   ib := Length(asStr);
   if (ib>0) then
     begin
     if rtf_iSSize<ib then ib1:=rtf_iSSize else ib1:=ib;
     for i:=1 to ib1 do
       szIO[i]:=asStr[i];
     try
       blockwrite(rtf_Outstream,szIO,ib1,ib2);
     except
       on E: Exception do ib2:=0;
       end;
     if (ib2=0) then kz:=6;
     asStr := Copy(asStr,rtf_iSSize+1,ib);
     end
   end;
 asStr := '';
end;

procedure rtf_ParIntoReport(
  var rtf_StrOut, asParname,asParvalue:string);
var ib:integer;
begin
  repeat
    ib := AnsiPos(asParname,rtf_StrOut);
    if ib>0 then
       rtf_StrOut := Copy(rtf_StrOut,1,ib-1)+asParvalue+
        Copy(rtf_StrOut,ib+Length(asParname),Length(rtf_StrOut));
  until ib=0
end;

function rtf_CreateReport (asDatFileName,
 asPicFileName, asRepFileName:string;
 cProc:callingProc; var istrd:integer):integer;

label DownIt, Down0, RepeatIt, CycleBottom;
var
rtf_StrInp,rtf_StrOut,
asDat,asParname,asParvalue: string;
szIO : array[1..rtf_iSSize] of char;
curlev,prevlev,kz : integer;
boolDOSdata,boolCRLF:Boolean;
st,asTmp:string;
i, ib, ib0, ib1, ib2, ilen, ilen2 : integer;
ch:char;
apch:array[1..2] of char;
pch:PChar;

begin
 pch := @apch; apch[2]:=#0;
 rtf_asSpec:='#';
 prevlev:=0;
 kz:=0;
 istrd:=0;
 rtf_asParMarker := ' ';
 rtf_asParMarker[1] := chr(rtf_ParMarker);
 AssignFile(rtf_Instream,asPicFileName);
 try
  Reset(rtf_Instream,1);
 except
  on E: Exception do kz:=2;
  end;
 if (kz<>0) then goto DownIt;
 rtf_StrInp := '';
 ib:=1;
 while not EOF(rtf_Instream) and (ib>0) do
   begin
   try
     begin
     blockread(rtf_Instream,szIO,rtf_iSSize,ib);
     for i:=1 to ib do
       rtf_StrInp := rtf_StrInp+string(szIO[i])
     end
   except
     on E: Exception do ib:=0;
     end;
   end;
 CloseFile(rtf_Instream);
 rtf_RTFpic := (AnsiPos('{\rtf',rtf_StrInp)=1);
 if rtf_RTFpic then rtf_maxLev:=9 else rtf_maxLev:=8;

 AssignFile(rtf_Instream,asDatFileName);
 try
   Reset(rtf_Instream,1);
 except
   on E: Exception do kz:=1;
   end;
 if kz<>0 then goto DownIt;
 AssignFile(rtf_Outstream,asRepFileName);
 try
   Rewrite(rtf_Outstream,1);
 except
   on E: Exception do
     begin
     CloseFile(rtf_Instream);
     kz:=3;
     end;
   end;
 if kz<>0 then goto DownIt;
 ib:=1;
 while ib>0 do
   begin
   ib := AnsiPos('\fcharset0',rtf_StrInp);
   if ib>0 then
     rtf_StrInp := Copy(rtf_StrInp,1,ib-1)+'\fcharset204'+
       Copy(rtf_StrInp,ib+10,Length(rtf_StrInp));
   end;
 ib:=1;
 ib0:=1;
 while ib>0 do
   begin
   ilen := Length(rtf_StrInp);
   ib := AnsiPos(rtf_asSpec,Copy(rtf_StrInp,ib0,ilen));
   if ib>0 then
     begin
     ib0 := ib0+ib-1;
     ib:=ib0;
     ib2 := AnsiPos(rtf_asSpec,Copy(rtf_StrInp,ib+1,ilen));
     if ib2=0 then begin kz:=7; goto DownIt end;
     asTmp := Copy(rtf_StrInp,ib+1,ib2-1);
     if (AnsiPos('FONT=',asTmp)=1) then
        begin
        asTmp := Copy(asTmp,6,rtf_iSSize);
        AddFontResource(PChar(asTmp));
        end;
     ilen2 := Length(asTmp);
     ib2 := ib2+ib+1;
     if (ilen2=2) then
        if (asTmp[1]='@') then
          begin
          rtf_asSpec[1] := asTmp[2];
          rtf_StrInp := Copy(rtf_StrInp,1,ib-1)+
           Copy(rtf_StrInp,ib2,ilen);
          goto RepeatIt;
          end;

     if ilen2>0 then
      begin
      if AnsiPos('\''',asTmp)=0 then
       begin
       ib1:=1;
       while ib1<=ilen2 do
        begin
        ch := asTmp[ib1];
        if not (((ch>='a') and (ch<='z')) or (ch='_') or
        ((ch>='A') and (ch<='Z')) or
        ((ch>='0') and (ch<='9'))) then
         begin
         if ((ch='{') or (ch='\')) then
           begin
           ilen2 := AnsiPos(' ',asTmp);
           if (ilen2=0) then
             ilen2 := AnsiPos('}',asTmp);
           if (ilen2=0) then ilen2:=ib1;
           end
         else
           ilen2 := ib1;
         asTmp := Copy(asTmp,1,ib1-1)+
           Copy(asTmp,ilen2+1,rtf_iSSize);
         ilen2 := Length(asTmp);
         end
        else
         ib1 := ib1+1;
        end;
       end;
      if (((asTmp>'D0') and (asTmp<='D9')) or
      ((asTmp>'0D') and (asTmp<='9D'))) then
        begin
        if (asTmp[1]='D') then
         curlev := atoi(Copy(asTmp,2,1))
        else
         curlev := atoi(Copy(asTmp,1,1));
        asTmp := Copy(rtf_StrInp,ib2,ilen);
        if (rtf_RTFpic) then
          begin
          ib2 := AnsiPos('}',asTmp);
          if ib2=1 then
            begin
            asTmp := Copy(asTmp,2,ilen);
            ib2 := AnsiPos('}',asTmp);
            end;
          ib1 := AnsiPos(rtf_asSpec,asTmp);
          if (ib1>0) and (ib1<ib2) then ib2 := ib1;
          end
        else
          ib2 := 1;
        st := ' ';
        st[1] := chr(curlev);
        rtf_StrInp := Copy(rtf_StrInp,1,ib-1)+st+
          Copy(asTmp,ib2,ilen);
        end
      else
        begin
        if asTmp='DATE' then
         asParvalue := FormatDateTime('dd.mm.yyyy',Date())
        else
        if asTmp='TIME' then
         asParvalue := FormatDateTime('hh:mm',Time())
        else
        if asTmp='EOP' then
          if rtf_RTFpic
            asParvalue := '{\page}'
          else
            asParvalue := '{\014}'
        else
         asParvalue := rtf_asParMarker+asTmp+rtf_asParMarker;
        rtf_StrInp := Copy(rtf_StrInp,1,ib-1)+
         asParvalue+Copy(rtf_StrInp,ib2,ilen);
        end
      end
     else
      rtf_StrInp := Copy(rtf_StrInp,1,ib-1)+
         '\''23'+Copy(rtf_StrInp,ib2,ilen);
     end;

RepeatIt:

   end;

 rtf_StrOut := '';
 boolDOSdata := false;
 boolCRLF:= false;
 while not eof(rtf_Instream) and (kz=0) do
   begin
   asDat:='';
   ib := 1;
   while ib>0 do
     begin
     try
       blockread(rtf_Instream,apch,1,ib);
     except
       on E: Exception do begin ib:=0; kz:=1 end
       end;
     ch := apch[1];
     boolCRLF := not boolCRLF;
     if (ch=#13) or (ch=#10) then
       ib := 0
     else
       if (ib>0) then
         begin
         if (boolDOSdata) then OemToChar(pch,pch);
         asDat := asDat+Copy(apch,1,1);
         boolCRLF := false;
         end
     end;
   if boolCRLF then inc(istrd);
   if @cProc<>nil then kz:=cProc(istrd);
   if kz<>0 then goto DownIt;
   if ((Length(asDat)<1) or (asDat[1]='#')) then
     goto CycleBottom;
   if AnsiPos('|DOS:',asDat)=1 then
     begin
     boolDOSdata := true;
     goto CycleBottom;
     end;
   if AnsiPos('|WIN:',asDat)=1 then
     begin
     boolDOSdata := false;
     goto CycleBottom;
     end;
   rtf_GetParameter(asDat,asParname,asParvalue,curlev);
   if (curlev<0) or (curlev>=rtf_maxLev) then
     begin kz:=5; goto DownIt end;

   ilen  := Length(rtf_StrInp);
   if (curlev=0) then
     begin
     ib1 := AnsiPos(asParname,rtf_StrOut);
     if (ib1=0) then
       begin
       ib1 := AnsiPos(asParname,rtf_StrInp);
       if (ib1>0) then
         begin
         ib2 := ilen+1;
         for ib:=ib1 to ilen do
           begin
           i := ord(rtf_StrInp[ib]);
           if (i>0) and (i<rtf_maxLev) then
             begin
             ib2:=ib;
             goto Down0;
             end;
           end;
Down0:
         rtf_StrOut := rtf_StrOut+Copy(rtf_StrInp,1,ib2-1);
         rtf_StrInp := Copy(rtf_StrInp,ib2,ilen);
         end
       end;
     rtf_ParIntoReport(rtf_StrOut,asParname,asParvalue);
     end
   else
     begin
     asTmp := ' '; asTmp[1] := chr(curlev);
     ib1   := AnsiPos(asTmp,rtf_StrInp);
     ib2   := AnsiPos(asTmp,
       Copy(rtf_StrInp,ib1+1,ilen));
     if (ib2=0) then goto CycleBottom;
     asTmp := Copy(rtf_StrInp,ib1+1,ib2-1);
     if (prevlev=0) then
       begin
(*
        
   :   
       asParvalue := ' '; asParvalue[1] := chr(1);
       if (curlev>1) then
         ib1 := AnsiPos(asParvalue,rtf_StrInp);
 asParvalue     , 
    .       0-
   .
*)
       st := ' '; st[1] := chr(1);
       if (curlev>1) then
         ib1 := AnsiPos(st,rtf_StrInp);
       if (ib1>1) then
         begin
         rtf_StrOut := rtf_StrOut+Copy(rtf_StrInp,1,ib1-1);
         rtf_StrInp := Copy(rtf_StrInp,ib1,ilen);
         end
       end;
     rtf_StrOut := rtf_StrOut+asTmp;
     while Length(asParname)>0 do
       begin
       rtf_ParIntoReport(rtf_StrOut,asParname,asParvalue);
       rtf_GetParameter(asDat,asParname,asParvalue,ib1);
       end;
     rtf_StrIntoReport(rtf_StrOut,kz);
     if kz<>0 then goto DownIt;
     end;
   prevlev := curlev;

CycleBottom:

   end;
 rtf_StrOut := rtf_StrOut+rtf_StrInp;
 rtf_StrIntoReport(rtf_StrOut,kz);

DownIt:

 try
  begin
  CloseFile(rtf_Instream);
  CloseFile(rtf_Outstream);
  end
 except
   on E: Exception do
  end;
 rtf_CreateReport := kz
end;
end.